#include "stdafx.h"
#include <cassert>
#include <fstream>
#include <iostream>
#include <iostream>
#include <boost/smart_ptr.hpp>
#include <boost/algorithm/string.hpp>
#include "tinyxml2.h"
#include "Fish_SeniorItemDropCFG.h"
#include "FileEncrypt.h"
std::auto_ptr<Fish_SeniorItemDropCFG> Fish_SeniorItemDropCFG::msSingleton(nullptr);

int Fish_SeniorItemDropCFG::GetCount()
{
	return (int)mMapData.size();
}

const Fish_SeniorItemDropCFGData* Fish_SeniorItemDropCFG::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

boost::unordered_map<int, Fish_SeniorItemDropCFGData>& Fish_SeniorItemDropCFG::GetMapData()
{
	return mMapData;
}

void Fish_SeniorItemDropCFG::Reload()
{
	mMapData.clear();
	Load();
}

void Fish_SeniorItemDropCFG::Load(const std::string& path)
{
	std::ifstream readStream(path, std::ios::binary);
	if (!readStream.is_open())
	{
		assert(false);
		return;
	}
	readStream.seekg(0, std::ios::end);
	int fileSize = readStream.tellg();
	boost::shared_array<char> buffer(new char[fileSize+1]);
	buffer.get()[fileSize] = '\0';
	readStream.seekg(0, std::ios::beg);
	readStream.read(buffer.get(), fileSize);
	readStream.close();
	FileEncrypt::decryptBuffer( buffer, fileSize );
	tinyxml2::XMLDocument xmlDoc;
	auto result = xmlDoc.Parse(buffer.get(), fileSize);
	if (result != tinyxml2::XML_SUCCESS)
	{
		assert(false);
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		assert(false);
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		Fish_SeniorItemDropCFGData data;
		data.mID = element->IntAttribute("ID");
		data.mItemId = element->IntAttribute("ItemId");
		data.mWeight = element->IntAttribute("Weight");
		{
			const char* Turret = element->Attribute("Turret");
			std::vector<std::string> vecTurret;
			boost::split(vecTurret, Turret, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecTurret.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecTurret[i].c_str(), &temp))
				{
					data.mTurret.push_back(temp);
				}
			}
		}
		{
			const char* DropCount = element->Attribute("DropCount");
			std::vector<std::string> vecDropCount;
			boost::split(vecDropCount, DropCount, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecDropCount.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecDropCount[i].c_str(), &temp))
				{
					data.mDropCount.push_back(temp);
				}
			}
		}
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		assert(mMapData.find(data.mID) == mMapData.end());
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
}

void Fish_SeniorItemDropCFG::Load()
{
	Load("../Config/Fish_SeniorItemDropCFG.xml");
}

Fish_SeniorItemDropCFG* Fish_SeniorItemDropCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new Fish_SeniorItemDropCFG());
	}
	return msSingleton.get();
}
